% theta = [theta_t; theta_x; theta_sigma]
% theta_sigma = log (sigma)
% all_pairs: cell of training pairs x^i > x^j
%  idx_global: global indices in big matrix of the whole system
%  ind_t, ind_x: indices in K^t and K^x
%
% Optionally:
%    - tstar: features of new user
%    - test_pairs: pairs where I want to make prediction
function [f, Kx, Kinv, W, L] = approx_gppe_laplace_fast(covfunc_u, covfunc_x,...
    params_u, params_it, u, x, all_pairs, idx_global, idx_global_1, idx_global_2, ind_t, ind_x, M, N)
tol = 1e-6;                   % tolerance for when to stop the Newton iterations
persistent fvis;
%covfunc_t = check_covariance(covfunc_t);
%covfunc_x = check_covariance(covfunc_x);

%%[theta_t, theta_x, theta_sigma] = get_gppe_parameters(covfunc_t, covfunc_x, theta, t, x);

%theta_t = theta(1);
%theta_x = theta(2);
%theta_sigma = theta(3);
sigma = .1; %exp(theta_sigma); 
%clear theta;

n = M*N; % need to change this when not everthing is fully observerd

%Kt = feval(covfunc_t{:}, theta_t, t); 
%Kx = feval(covfunc_x{:}, theta_x, x);  

[Kt] = feval (covfunc_u, params_u{1,2}, params_u{2,2}, params_u{3,2}, u);  
[Kx] = feval (covfunc_x, params_it{1,2}, params_it{2,2}, params_it{3,2}, x); 


%Kold  = kron(Kt, Kx); Kold  = Kold(idx_global, idx_global);
%K = Kt .* Kx  %(ind_t, ind_t)  %(ind_x,ind_x);
K = kron (Kt, Kx);


%% We do Newton method here psi is the  approximate log posterior  
%if (isempty(all_pairs{M}))
%
f = zeros(n,1);
%
%f = NaN*ones(n,1);
f(idx_global) = 0;
%    clear fvis;
%else
%    f(idx_global) = fvis; % we initialize with previous value
%end
fvis = f; %(idx_global); % f visible

loglike = log_likelihood_gppe(f, sigma, all_pairs, M, N);
Kinv = inv( K );                                             % Need to do numerically efficient/stable later
psi_new = loglike - 0.5 * fvis'*Kinv*fvis; 
psi_old = -Inf;                                            % make sure while loop starts
%fprintf('psi_new = %.6f\n', psi_new);
while ( (psi_new - psi_old) > tol  )                       % begin Newton's iterations
  psi_old = psi_new;   
  deriv =   deriv_log_likelihood_gppe_fast(f, sigma, all_pairs, ...
      idx_global_1, idx_global_2, M, N);
  W     = - deriv2_log_likelihood_gppe_fast(f, sigma, all_pairs, ...
      idx_global_1, idx_global_2, M, N);
  
  %W     = W(idx_global, idx_global);   % only at visible locations
  L = chol( correct_singular( W + Kinv ) )';
  fvis  = solve_chol(L', deriv + W*fvis);  % (idx_global)      % (W + Kinv)^-1 (deriv + Wf)
  % fvis  = chol(L', deriv(idx_global) + W*fvis);        % (W + Kinv)^-1 (deriv + Wf)
  f = fvis;    % (idx_global)                                  % updating visible values  
  loglike = log_likelihood_gppe(f, sigma, all_pairs, M, N);
  
  psi_new = loglike - 0.5 * fvis'*Kinv*fvis;
  
  
 %fprintf('psi_new = %.6f\n', psi_new);
end        


return;
  

