% Doing things naively now
% can do things more efficiently (?)
% derivative wrt f
function deriv_loglike = deriv_log_likelihood_gppe_fast(f, sigma, all_pairs, ...
    idx_global_1, idx_global_2, M, N)
if (isempty(idx_global_1) || isempty(idx_global_2))
    error('GPPE:deriv_log_likelihood_gppe_fast', 'idx_global_1 and idx_global_2 Undefined');
end

M = length(all_pairs);
n = M*N;
z = ( f(idx_global_1) - f(idx_global_2) )/sigma;
cdf_val = normcdf(z); pdf_val = normpdf(z);    
val = (1/sigma) * pdf_val./cdf_val;
coef = get_cumulative_val(idx_global_1, val, n);
coef = coef - get_cumulative_val(idx_global_2, val, n);
deriv_loglike = coef;


return;

